发布日期：`2022-01-13`

>[success] 1.3.3版本目前已进入维护状态，不再新增功能，项目可继续使用，但无法获得以后版本发布的新功能。

- ## BUG修正
	 - **202506160932：**
		 - 修复日志文件下载权限问题
		 - 修复其他已知BUG
	 - **202501101522：**
		 - 修复gUtil.round对负数四舍五入问题，如： 
		```
		 // JS和其他语言对 -0.5 负数round的结果存在偏差
		 // 原计算结果：
		 gUtil.round(-1.235,2) = -1.23 
		 // 现调整结果：
		 gUtil.round(-1.235,2) = -1.24
		 // 正数结果不变：
		 gUtil.round(1.235,2) = 1.24
		```
		 - 修复其他已知BUG
	 - **202406201247：**
		 - 地区库世界国家数据补全（遗漏了巴勒斯坦、哈萨克斯坦、法罗群岛、摩纳哥、南苏丹等几国）
		 - 更新最新（2023年）国家统计局地区库，取消已合并的区、新增新的地区
		 - 修复其他已知BUG
	 - **202403151628:**
		 - 修复一个元组件，在不同页面内，被同时打开时，组件内表格最大化失效问题。
		 - 修改其他已知的BUG
	 - **202311291118:**
		 - 修复开发环境推算控件默认名称时无法校验tabpage下控件的问题。
		 - 修复打包文件中，资源文件中文名称的情况下，在linux下升级后变成乱码问题
		 - 修改其他已知问题
	 - **202310311047:**
		 - 修复缓存内存溢出问题。
	 - **202310180925:**
		 - 修复谷歌浏览器下代码字体变小问题。
		 - 修复调试时，数组元素为空的情况下，无法打开数组列表问题
	 - **202309221531:**
		 - 修复SQL升级语句归档号不能超过10的问题
		 - 修改其他已发现的BUG
	 - **202308311634:**
		 - 修复报表日期查询中，带有时间的日期格式，点击月报错问题
	 - **202308241303：**
		 - 开发环境打包优化：加快打包速度，解决打包时内存溢出问题
		 - 修复了开发环境打包经常报连接超时问题
		 - 修复对话框关闭后，页面上点击回车仍旧会触发对话框事件的问题
	 - **202308220850：**
	 	 - 增加WPS文件预览功能，实现与solution.wps.cn在线预览服务对接
			 - 登录weboffice开放平台创建应用，配置相应的回调地址
			 - 在系统配置文件中设置weboffice申请到的AppSecret 、AppID 
	 - **202306091122：**
		 - 开发环境增加编译包文件清理功能，清理规则：
			 - 一般编译包默认保存15天
			 - 开发者可以手工推迟清理时间
			 - 每个系统至少保留3个编译包
		 - 修正`$vs.redis.setnx`和`$vs.redis.rename`递归循环调用问题
		 - 日常其他已知问题修复。
	 - **202211291155**：
		 - 修复下拉过滤不支持特殊字符（如：&）问题
		 - 修复谷神脚本字符串转义字符无法表达问题，现在使用` #set($str='aa\nbbb')`可以输出换行符
		 - 打包后数据库密码支持加密保存
		 - 修复开发环境特殊建表SQL解析时导致死循环问题
	 - **202210311144:**
		 - 修复定时调度中，最后一天设定的情况下，短月（30天月）过渡到长月（31天月）时日期计算不正确的问题。
		 - 修复主页面中，用户即保存了查询条件模板，又保存了表格模板，且表格模板含有排序的情况下，触发两次查询，且数据被覆盖问题。
	 - **202210180857：**
		 - `$vs.date.getDbDate()：`返回数据类型变更为`Date`类型
		 - 新增`$vs.date.getDbTimeStamp()：`返回TimeStamp（带毫秒）类型
	 - **202209281713：**
		 - 远程访问组件设置等待超时时间（10分钟）
		 - 修复定时作业环境下的业务日志无法写到日志中心的问题
		 - 服务组件允许接受数组类型的json字符串，但是会转为 `$form.list`下的内容
		 - 修复`INT`类型数据未做自动类型转换问题而导致的Oracle批量新增失败的问题
	 - **202209221139:**
		 - 修复Oracle数据库下，明细表格批量数据保存时，部分数字类型的行没有填制（null）的情况下，报“表达式必须具有与对应表达式相同的数据类型”问题。
	 - **202209151531:**
		 - 明细表格`detailTable`和`inputForm`加载数据由原先任意条件就可以加载全表数据改为需要传值特殊条件才可以加载全表数据（防止条件匹配失败而导致的全表加载内存溢出）；若确实需要加载所有数据，则传值查询条件：`{isLoadAll:true}`
			 - 本功能默认关闭，可以通过添加参数`golden.control.load.is-skip-check=false`来开启。
			 - 开发启用方式：在资源管理服务中，添加微服务应用的`系统额外配置`
			 - 生产/测试环境：在打包时，增加`自定义配置`
			 - 注意：每个微服务应用都需要添加此配置
	 - **202208301146：**
		 - 修复`inputBox`地区组合`setFieldMustInput`无效问题。
		 - 修复tabpage控件套tabpage控件的情况下，编译js文件错乱问题。
	 - **202208031408：**
		 - 修复开发环境下，产品代码断点无法进入的问题
		 - 修复`Oracle`数据库下，`SQLTools.dateIntervalDAY`日期差出现小数问题
		 - 修复钉钉、微信、企业微信后台用户发送消息给协同用户时，无法找到用户信息的问题
	 - **202207251709：**
		 - 修正`$vs.http`返回时校验JSON格式失败的问题。
		 - 服务端谷神脚本增加直接调用页面保存方法：
			 - `$vs.proc.callPageSave()`:服务端调用页面的单据新增方法（一般用于接口等需要创建单据时与原保存代码复用的场景）。
			 - `$vs.proc.callPageUpdate()`:服务端调用页面的单据修改方法（一般用于接口等需要创建单据时与原保存代码复用的场景）。
		 - `$vs.util`增加新的API：
			 - `$vs.util.urlEncode($str:string):string`对字符串进行URLEncode编码
			 - `$vs.util.urlDecode($str:string):string`对字符串进行URLDecode解码
	 - **202207180906：**
		 - 修复邮件附件中文名称过长时，附件文字被下划线替代的问题。
		 - 修复用户在无菜单权限时，登录报错的问题
		 - 修复`$vs.dbTools.batchUpdate`一次修改行数过多时，重复执行第一页的情况
		 - 修复企业微信发送消息时，用户ID中含有空格的情况下无法收到消息的问题
	 - **202206280957：**
		 - 修正下拉选择控件粘帖后不会触发过滤问题
		 - 框架升级(2.3.10->2.6.8)
		 - 修复文件下载时未能根据上传文件名称下载的问题
		 - 修复`$vs.dbTools.batchUpdate`方法，当数据超过1000条时，只能更新部分数据问题。
	 - **202205231613:**
		 - 修正了微信扫描登录的情况下，由于浏览器缓存而导致无法正常登录的问题。
		 - 修正了主菜单收缩/展开导致右侧工作区控件高度错乱问题
	 - **202205071047:**
		 - 增加报表查询耗时分析功能，分析报表耗时环节
			 - 启用方式：在配置文件`application-conf.properties`增加配置项`golden.runtime.min-time-to-show=xxxx`
			 - 参数含义：报表执行超过多少时间后，在日志文件中打印耗时分析数据
			 - 参数单位：毫秒，默认`5000`，即，不配置的情况下，如果报表查询耗时超过5秒，则会自动打印耗时分析数据。
	 - **202204281652:**
		 - 修正`#try`语句`return`没有结束过程的BUG。
	 - **202204251537:**
		 - excel导出数据时按排序的数据进行导出
	 - **202204191259:**
		 - 修正`$vs.sqlTools.like`无法正常工作问题
		 - 优化三方接口accessToken无效时提示的错误编码。
	 - **202204181635:**
		 - 代码打包编译时，不再打包发布预警监控调度（预警监控属于项目行为不具备升级功能）。
		 - 后台保存时，增加对下拉必输字段反射值的非空校验
		 - 下拉控件BUG调整（当过滤无数据时，用户点击下拉空白处会导致下拉无法关闭的问题）
	 - **202204011051:**
		 - 添加静态资源浏览器缓存功能，对于js、css、图片等静态资源启动浏览器本地缓存，以加快访问速度和节约服务器带宽
	 - **202203291402:**
		 - 修正了下拉组件在中文输入法下，点击鼠标选文字不触发下拉查询问题
		 - 增加了编辑表格动态必输字段校验(需升级开发环境并重新编译)
		 - 修正了编辑表格动态必输字段无法切换回非必输字段的问题
		 - 修正了系统设置中表格水印选项无法取消的问题
	 - **202203281152：**
		 - 修正了微服务环境下数据字典下拉路由到主数据的问题
	 - **202203171544:**
		 - `GD_UPLOAD_FILES`谷神附件表增加业务扩展字段：
		```
		SEAL_PERSON、SEAL_DATE、SEAL_STATE、SEAL_NUM、FILE_STATE-- 业务预留系列
		REF_CODE1、REF_CODE2、REF_CODE3、REF_CODE4			  -- 业务代码预留
		REF_STR1、REF_STR2、REF_STR3、REF_STR4、REF_STR5		-- 业务文本预留
		REF_NUM1、REF_NUM2、REF_NUM3							-- 业务数字预留
		REF_FLAG1、REF_FLAG2、REF_FLAG3、REF_FLAG4、REF_FLAG5   -- 业务标记预留
		REF_DATE1、REF_DATE2、REF_DATE3、REF_DATE4			  -- 业务日期预留
		 　
		注意：这些字段谷神系统不使用，全部预留给业务系统使用，业务系统如何分配这部分字段均由业务系统自行决定。
		```
		 - 润乾报表支持图形报表的PDF打印和PDF导出（需要在服务器上配置SlimerJS及firefox插件），配置方式如下：
			 - 点击[这里](http://docs.steel56.com.cn/docs/gdfaas/gdfaas-1dn8n2knkbsv0)下载`slimerjs-0.10.3.zip`以及您服务器对应的`firefox运行包`
			 - 然后根据[润乾第三方图形报表配置规范](http://d.raqsoft.com.cn:6999/report/tutorial/dcydy88.html)要求配置`firefox运行包`环境
			 - 把`slimerjs-0.10.3.zip`解压缩后，上传到谷神主数据安装目录的根目录并重启主数据即可
	 - **202203081249：**
		 - 修正了条件判断语句中，操作符和括号之间没有空格时解析失败的问题。
	 - **202203040838：**
		 - 修正了子查询报表汇总合计问题。
	 - **202203031004：**
		 - 修正了`$vs.log.writeBusLog($billTypeCode,$billNo,$optType,$bill)`$bill参数为字符串时无法记录日志问题。
	 - **202202241204：**
		 - 修正了Oracle数据库在大数据量下，分页错乱问题
	 - **202202231501：**
		 - 修正了文件上传框中，公有文件无法下载问题
		 - 修正了编辑表格插入数据时无法添加到指定位置问题
		 - 修正了一个单据下含有多个inputForm的情况下，新增可能无法保存操作日志的BUG。
		 - 修正了编辑表格（企业版）批量拖动复制下拉列时，拖到合计行时，无法反射代码到值字段的问题
- ## 底层包版本升级说明 2.3.10->2.6.8

序号|包名			 |原版本			  |新版本
:-|:-				|:-					|:-
1 | spring-boot		| 2.3.10.RELEASE 	| 2.6.8
2 | spring-cloud	| Hoxton.SR11 		| 2021.0.3
3 | spring-framework| 5.2.14.RELEASE 	| 5.3.20
4 | hibernate		| 5.4.30.Final 		| 5.6.9.Final
5 | tomcat			| 9.0.45 			| 9.0.63
6 | fastjson		| 1.2.76 			| 1.2.83
7 | mybatis			| 3.5.6				| 3.5.6


- ## 新增功能
	 - **表格增加水印功能支持，防止数据被截图外泄**
		 - 开启方法：系统管理员登录->系统设置菜单->系统设置模块->表格设置
	 - **增量发布版本支持：**谷神支持增量版本发布功能。
	 - **`$vs.message`新增API：**
		 - `sendWeChatMessage(userId,userName,openId,msgTypeId,bill)`:发送微信公众号消息到指定openId的用户
		 - `sendCropWxMessage(userId,userName,openId,msgTypeId,bill)`:发送微信企业号消息到指定openId的用户
		 - `sendDingTalkMessage(userId,userName,openId,msgTypeId,bill)`:发送钉钉消息到指定openId的用户
	 - **`tabPage`增加方法：**`tabPage.tabPage0.isShow()`，返回当前TAB标签是否处于可视状态。
	 
	 
- ## 代码结构版本号
	 - 当前代码结构版本号：不支持