发布日期：`2020-05-09`

- ## 新增功能：
    - 编辑表格必须字段在表头文字处增加“`*`”
    - Tab增加`enabled、disabled、hide、show`方法
    - 表格增加行号列功能
    - 增加单据草稿功能（单据模版）
    - 表格增加操作列的功能
    - 增加了读取配置文件的API，`$vs.properties.getProperty`
    - `$vs.util`增加方法：`getMapKeys`获取一个Map对象下的所有键值，调用方式：
       `#set($list=$vs.util.getMapKeys($form))`
    - `$vs.util`增加方法：`listClone`克隆列表
    - 优化：地区组件选择后，修改状态下，初始化了市和县的下拉，这样解决了原先必须切换省后才能选择市的问题
    - `$vs.util`增加方法：`isString`、`isMap`、`isList`
    - 下拉选择组件增加支持切换组件源功能（`inputForm`和`itemTable`两个控件都支持）
    - 增加快捷执行过程脚本的方法 : 
	` #set($bean=$vs.proc.invoke('com.golden.bdp.contract','get',$form,'A','B'))`
    - 权限分配插件优化：点击菜单目录树，可以显示目录下面的所有的子菜单；优化菜单目录树，当目录下无子目录时，图标显示为无子目录的图标。
    - 开发界面增加全局代码查询器
    - $vs.util增加字符串处理函数：
		`leftTrim`、`rightTrim`、`strLeft`、`strRight`、`strLen`、`strTrueLen`、
		`toUpperCase`、`toLowerCase`、`isNumeric`、`startsWith`、`endsWith`、
		`isContain`、`strPos`、`substring`、`strReplace`、`strReplaceAll`
	- 子页面`inputForm`增加“更多按钮”区（效果图如下：）
	![](http://docs.guthon.com/uploads/gdfaas/images/m_a901c5470548edbfca8e806c21dcf697_r.png)
	- 窗口关闭增加onBeforeWinClose事件
	- 窗口页面增加self.getIsChange()函数，用于获取页面上的可编辑控件是否被修改；代码模版增加是否修改判断，当窗口数据被修改，且用户需要关闭时自动弹出是否放弃当前数据的提示。
    - 编辑表格下拉列支持通用定义:
       `table.reBindSelect(rowIndex,fieldId,params,compId,codeType,list)` rowIndex小于0 表示所有行
       `table.setSelectDropdownDatas(rowIndex,fieldId,params,compId,codeType,list)` rowIndex小于0 表示所有行
    - 下拉组件params支持函数（inputForm和itemTable都支持），调用方法如下：
    ```
        // 表格
        table.reBindSelect(-1,'CODE',function(params){ // params 只有表格的情况下才有，表示当前行的参数
			var param = {};
			
			param.STATUS = 1;
			param.FATHER = inputForm.get('MEMBER_CODE');
			
			return param;
		})
		
		// 输入框
		inputForm.reBindSelect('CODE',function(){ // 此处函数无参数
			var param = {};
			
			param.STATUS = 1;
			param.FATHER = inputForm.get('MEMBER_CODE');
			
			return param;
		});
		
		```
	- GdScript增加调用服务组件的方法:
	`$vs.proc.runServiceComp(String compId, Map<String, Object> param):Map<String,Object>;`
	
	```
		#set($form = $vs.util.newMap())
		#set($form.USER_ID = $vs.user.USER_ID)
		
		#set($result = $vs.proc.runServiceComp('com.golden.remote.getUserInfo',$form))
		
		$vs.log.info($result) // $result 为服务组件返回数据的对象，可以再服务组件中赋值
		
	 ```
	- `$vs.dbTools`增加方法：
		- `$vs.dbTools.insert(tableName,data,isNeedDataAuth)` : isNeedDataAuth - 是否需要控制数据权限
		- `$vs.dbTools.delete(tableName,where,isNeedDataAuth)` : isNeedDataAuth - 是否需要控制数据权限
		- `$vs.dbTools.update(tableName,data,where,isNeedDataAuth)` : isNeedDataAuth - 是否需要控制数据权限
		- `$vs.dbTools.count(tableName,where,isNeedDataAuth)` : isNeedDataAuth - 是否需要控制数据权限

	- `inputForm`和`searchForm`增加方法：
		- `setFieldMustInput(name,isMustInput)`： 设置字段是否必输（必须设计时为非必须字段才可修改）
		- `isFieldMustInput(name)`：获取字段是否必输
	- `mainTable`和`itemTable`控件增加方法：
		- `getAllColumns()`：获取所有列（含隐藏列，若用户移动了列，则给出的也是移动后的列）
		- `getAllDisColumns`：获取所有列（不含隐藏列，若用户移动了列，则给出的也是移动后的列）
		- `setHeaderTitle(fieldId,name)`：设置列标题。
		- `getHeaderTitle(fieldId)`：获取列的显示标题。
	- `mainTable`主表格控件增加快捷`导出EXCEL`选项，效果如下
	
	![](http://docs.guthon.com/uploads/gdfaas/images/m_4a93ef7983d16ff68613ad80d4e70cdd_r.png)
	
	实现效果：
	
	![](http://docs.guthon.com/uploads/gdfaas/images/m_c98ec966777be0769112b7159f43e21c_r.png)
	
	- `gUtil`增加方法：
		- `closeCurTabWin(isForceClose:boolean,succfun:Function)`：新增参数
			- `isForceClose`：是否强制关闭（跳过`onBeforeWinClose`事件)，`true` - 强制关闭（不调用`onBeforeWinClose`事件，跳过检测当前单据是否被修改） other 正常关闭
			- `succfun`：关闭窗口成功后回调（若关闭失败不回调）
	- 增加微服务Tab页显示顺序（在应用管理编辑页面中可以设置排序顺序）
	- 增加各微服务独立的首页功能支持，所有微服务都具备各自个性化的首页面，在用户切换微服务时自动加载对应的首页面
	- 开发环境菜单重新整理
	- 取消`searchForm`的页面事件功能。
	- 过程脚本方法增加强制挂载调试信息功能，用于接口或作业调度调试
	- 开放环境增加视图导出Hibernate模型功能。
	- `inputForm`Excel文件上传控件优化：取消删除和下载按钮，只保留模版下载按钮
	- `mainTable`和`itemTable`控件增加新功能：
		- 保存当前布局、另存当前布局、恢复我的布局、恢复默认布局
		![](http://docs.guthon.com/uploads/gdfaas/images/m_d1c9403f5433798c0a57caf9ae706ae1_r.png)


- ## BUG修正：
    - 微服务插件：插件下载未漫游到各个目标微服务
	- `$vs.util.mapClone`未能深度复制，导致复杂对象克隆后存在引用关系。
	- 地区下拉组件切换省后市没有动态绑定问题。
	- 解决`table.setDataValue`无法对隐藏（不显示）的字段赋值问题
	- 优化代码全文检索的查询速度
	- 解决`$vs.mq.subscribe`多次订阅时，报组名称重复问题
	- 解决`inputForm`组件中的radio、checkbox控件在只读情况下，无法获取数据的情况。
    - 权限分配时，菜单下拉会导致界面下拉；
    - 主页面情况下，报表显示报未传值`parentPageId`问题
	- 微服务跨服务窗口调用的情况下，数据字典指向页面所在的数据源。
		- 修正过程脚本新增函数界面无法选择返回值问题。
	- 修正过程脚本删除函数时，界面上数据删除错行问题。
	- 修正`页面脚本`视图中，`inputForm`和`searchForm`漏掉的页面事件。
	- 修正了页面信息修改时，修改了页面别名而页面源码中别名未改的问题。
	- 修正了表格编辑时下拉列宽度和表格宽度不一致问题。
	- `DEBUGGER`:
		- 修正了当步入函数时，参数没有变成函数的参数
		- 增加过程脚本函数内单步执行时，走到最后一行后，可以自动跳回上级调用脚本继续调试