发布日期：`2020-05-30`

- ## 新增功能：
	- 增加UNI-APP开发的支持（谷神做后台服务，UNI-APP做前端），具体详见[APP开发指南](http://docs.guthon.com/docs/gdfaas/gdfaas-app-develop "APP开发指南")。
	- 取消表格缓存多字段唯一键值的支持，对应的方法，同步取消，请不要再使用
		- ~~$vs.cache.getBean(tableId,dataField0,dataField1)~~:方法已取消
		- ~~$vs.cache.getBean(tableId,dataField0,dataField1,dataField2)~~:方法已取消
		- ~~$vs.cache.getBean(tableId,dataField0,dataField1,dataField2,dataField3)~~:方法已取消
		- ~~$vs.cache.getBean(tableId,dataField0,dataField1,dataField2,dataField3,dataField4)~~:方法已取消
		- ~~$vs.cache.getValue(tableId,dataField0,dataField1)~~:方法已取消
		- ~~$vs.cache.getValue(tableId,dataField0,dataField1,dataField2)~~:方法已取消
		- ~~$vs.cache.getValue(tableId,dataField0,dataField1,dataField2,dataField3)~~:方法已取消
		- ~~$vs.cache.getValue(tableId,dataField0,dataField1,dataField2,dataField3,dataField4)~~:方法已取消
	- 缓存算法优化：`$vs.dbTools.delete`、`$vs.dbTools.update`方法增加对修改的数据的缓存处理
	- `$vs.http`方法增加`$header`参数，使用方法如下：
	```
		#set($header=$vs.util.newMap())
		#set($header.put("auth-code","123456"))
		#set($header.authiton = "12345667777")
		
		#set($ret = $vs.http.postBodyWithMapReturn($url,$data,'utf-8','application/json',$header))
		
	```
	
	- 开发环境：模块开发页面，增加版本管理，防止修改冲突被覆盖源码。
	- 开发环境：模块开发页面，增加版本记录查看功能（版本对比功能暂未实现）
	![](http://docs.guthon.com/uploads/gdfaas/images/m_49be353edf3fbd4aa362fcdaa3feee43_r.png)
	
	- 开发环境：服务事件代码（`GdScript`）**调试断点添加（删除）改为鼠标双击事件**。
	- `$vs.dbTools`增加方法`findPage($sql,$form)`
	```
		#set($form.USER_ID='0000')
	
		#set($sql = 'select * from BASIC_USER where 1=1 ')
		#set($sql = $sql + ' and SQLTools.like(user_id,#{USER_ID})')
		
		// 下面语句： 如果$form.USER_NAME 为空，则返回空字符串，否则返回 ' and USER_NAME = #{USER_NAME} '
		#set($sql = $sql + $vs.util.sqlHelper.and($form,'USER_NAME'))
		
		#set($result.page = $vs.dbTools.findPage($sql,$form))
		
	```
	- `$vs.sqlHelper`增加方法：
		- `$vs.sqlHelper.andLike($form,$fieldId)`
		- `$vs.sqlHelper.andLike($form,$fieldId,$dataFieldId)`
		- `$vs.sqlHelper.date($form,$fieldId)`
		- `$vs.sqlHelper.date($form,$fieldId,$dataFieldId)`
		- `$vs.sqlHelper.date($form,$fieldId,$dataFieldId,$dateFmt)`
		- `$vs.sqlHelper.andDate($form,$fieldId)`
		- `$vs.sqlHelper.andDate($form,$fieldId,$dataFieldId)`
		- `$vs.sqlHelper.andDate($form,$fieldId,$dataFieldId,$dateFmt)`
		- `$vs.sqlHelper.dateBetween($form,$fieldId,$startDateField,$endDateField)`
		- `$vs.sqlHelper.andDateBetween($form,$fieldId,$startDateField,$endDateField)`
	
	- 增加数据权限SQL提取对象`$vs.dataAuth`
		- `$vs.dataAuth.andDataAuth($tableId)`
		- `$vs.dataAuth.andDataAuth($tableId,$tableAliasName)`
	- 增加代码打开主窗口方法：
		- `gUtil.openMainWin(pageId,params)`
	- `$vs.cache`增加方法：
		- `$vs.cache.putCache($key,$data)`:添加数据到缓存（若redis启用则放到redis否则放到服务器本地内容），数据永久有效
		- `$vs.cache.putCache($strCacheKEY,$data)`:添加数据到缓存（若redis启用则放到redis否则放到服务器本地内容）
		- `$vs.cache.getCache($strCacheKEY)`：获取缓存
		- `$vs.cache.removeCache($strCacheKEY)`:删除缓存
		- `$vs.cache.putUserSessionCache($key,$data)`：把数据放到用户会话缓存中（用户退出登录后数据连带删除)
		- `$vs.cache.getUserSessionCache($key)`:从用户会话缓存中获取数据
		- `$vs.cache.removeUserSessionCache($key)`:从用户会话缓存中删除数据
<br/>

	`^^^^^^^^^^^^^^^^^^^^^^^^^^^^`
	- 新增线程处理方法：`$vs.thread.run($strProcName,$funName,$args...)`
	- `$vs.dbTools`增加批量新增方法`$vs.dbTools.batchInsert($tableName,$datas)`
	- 过程脚本函数增加防覆盖冲突标记。
	- 增加`$vs.math`方法：
		- `$vs.math.sqrt($d)`:计算平方根 sqrt(16) = 4.0
		- `$vs.math.cbrt($d)`:计算立方根 cbrt(8) = 2.0
		- `$vs.math.pow($d)`:计算X次方
		- `$vs.math.max($d,$ds...)`:获取最大数
		- `$vs.math.min($d,$ds...)`:获取最小数
		- `$vs.math.abs($d)`:获取绝对值
		- `$vs.math.ceil($d)`:计算最接近给定值的最大整数
		- `$vs.math.floor($d)`:计算最接近给定值的最小整数
		- `$vs.math.random()`:获取 0 - 1 的随机数
		- `$vs.math.random($max)`:返回 0 - ($max - 1)的整数

- ## BUG修正：
	- 修正了编辑表格下拉列不能手工输数据问题（非强制下拉）