发布日期：`2021-11-19`

- ## 新增功能
	 - 应用端增加，`系统设置`->`预警监控管理`，客户可自定义预警监控信息。
	 - 应用端任务栏增加右键菜单，可以把当前窗口在新的窗口打开
	 - 应用端增加菜单搜索功能
	 - 连接菜单功能优化
		- 连接菜单具有自己独立的权限分配功能（和正常菜单权限分配方式相同）
		- 当上级菜单没有分配权限而连接菜单分配了权限的场景下，上级菜单对操作员不可见，连接菜单对操作员可见
	 - `$vm.openDialog`函数增加 `title` 参数，可以动态指定打开的对话框窗口标题。
	 - `$vm.open`函数增加 `title` 参数，可以动态指定打开编辑窗口的窗口标题。
	 - `$vs.dataAuth` 更名为 `$vs.auth` 老代码继续可以使用 `$vs.dataAuth`（建议修改为`$vs.auth`）新开发的代码必须使用`$vs.auth`。
	 - `$vs.auth`增加用户权限判断方法：
		 - `$vs.auth.getUserAuths($mkId,$auths,$userId)`: 获取指定用户对指定模式是否存在指定的按钮权限
		 - `$vs.auth.getUserAuths($mkId,$auths)`: 获取当前登录用户对指定模式是否存在指定的按钮权限
		调用说明：
		```
		#set($auth = $vs.auth.getUserAuths($mkId,'select,edit'))
		#if ($auth.select eq 1)
		    $vs.log.info('当前登录用户具有模块['+$mkId+']的查询权限')
		#end
		```
	 - 增加获取当前登录用户是否含有按钮权限方法（异步）：`gUtil.getUserAuths(mkId,auths,callback)`
	 - 增加获取当前登录用户是否含有按钮权限方法（同步）：`gUtil.getUserAuthsSynch(mkId,auths)`
	 - 增加页面获取当前登录用户是否含有按钮权限方法（异步）：`$vm.getUserAuths(auths,callback)`
	 - 增加页面获取当前登录用户是否含有按钮权限方法（同步）：`$vm.getUserAuthsSynch(auths)`
	 - 按钮设置增加“权限隐藏”算法，根据配置，可以设置用户无权限时，自动隐藏按钮的功能
	 ![](http://docs.guthon.com/uploads/gdfaas/images/m_5d64a90ce7a5e0591657304e4e00050f_r.png)
	 - `$vs.dbTools`增加方法：
		- `$vs.dbTools.remoteList(systemId,strSql,$where)` : 执行数据库查询列表记录（跨服务）
		- `$vs.dbTools.remoteUniqueResult(systemId,strSql,$where)` : 执行数据库查询单条记录（跨服务）
	 - `$vs.date`增加方法：
		- `$vs.date.getDateWeek($date)`：获取给定日期属于第几周
		- `$vs.date.getMonthFirstDate($date)`:获取指定日期的月份第一天
		- `$vs.date.getMonthLastDate($date)`:获取指定日期的月份最后一天
		- `$vs.date.getMonthDays($date)`:获取指定日期的月份有多少天
	 - `inputForm`、`gridForm`增加分割线折叠控件功能，设置分割线属性为`允许折叠控件`后开启
	 ![](http://docs.guthon.com/uploads/gdfaas/images/m_dd7955bffb95c1e4c57d2f57306ec94d_r.png)
	 - 按钮增加`分隔按钮`，含下拉菜单按钮
	 - 查询框增加`checkbox`控件（查询时采用`IN`）
	 - `inputForm`控件增加密码控件`password`
	 - `GusenScript`增加字符串块语法，如：
	 ![](http://docs.guthon.com/uploads/gdfaas/images/m_7ba7193af923ee73a72bba470b05cba5_r.png)
	 
	 - 增加文件http上传API
		- `$vs.http.postFileBuffer($url:string,$param:Map,$fileKey:string,$fileName:string,$buffer:byte[],$header:Map):string`
		- `$vs.http.postFile($url:string,$param:Map,$fileKey:string,$fileName:string,$localFilePath:string,$header:Map):string`
	 - 表格服务事件中，增加`$isSum`参数，用于标识当前请求是否sum合计请求。
	 - `$vs.dbTools.delete`、`$vs.dbTools.update`、`$vs.dbTools.select`、`$vs.dbTools.count`上述4个函数增强`$where`的解析规则，允许条件字段采用`$list`传值作为`in`的查询条件，如：
	```
	#set($codes = $vs.util.newList('0010','0011','0012'))
	#set($where = $vs.util.newMap())
	#set($where.USER_ID = $codes)
	#set($list = $vs.dbTools.select('BASIC_USER',$where))
	// 在解析SQL语句时解析为：BASIC_USER.USER_ID in ('0010','0011','0012') 以实现多值查询
	```
	 - 新增SQL统计函数：`$vs.dbTools.countSQL($sql,$where):int`
	 - `$vs.dbTools.findPage`、`$vs.dbTools.list`、`$vs.dbTools.execute`、`$vs.dbTools.uniqueResult`:
	 	增加参数`$isEnableDataAuth`标识是否启用数据权限，默认不起用（数据权限算法和子查询数据权限算法相同）
	 - `$vs.dbTools.findPage`、`$vs.dbTools.list`、`$vs.dbTools.execute`增加报表查询模式下查询条件支持。