# 微信服务号
服务号是公众号的一种，为企业和组织提供更强大的业务服务与用户管理能力，主要偏向服务类交互。与普通订阅号相比，更适用于搭建服务平台。

# 微信公众平台
[微信公众平台](https://mp.weixin.qq.com/ "微信公众平台")是运营者通过公众号为微信用户提供资讯和服务的平台，而公众平台开发接口则是提供服务的基础，开发者在公众平台网站中创建公众号、获取接口权限后，可以通过阅读[接口文档](https://developers.weixin.qq.com/doc/offiaccount/Getting_Started/Overview.html "接口文档")来帮助开发。

# AppId/AppSecret
AppId是公众号的唯一身份标识，AppSecret是对应的调用密钥。
**查看方式：**请先确认已注册微信公众号并通过验证。然后登录微信公众平台，获取公众号的appid和secret（现在secret好像不支持查看了，只能重置）。
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_3256731205aaf06a84c8bd44fee27e68_r.png)

## 授权地址
在微信登录身份验证后，会回调插件的接口，但回调域名必须在微信公众平台配置。
**配置方式：**到[公众平台官网](https://mp.weixin.qq.com/cgi-bin/registermidpage?action=index&lang=zh_CN&token= "公众平台官网")中的“开发 - 接口权限 - 网页服务 - 网页帐号 - 网页授权获取用户基本信息”的配置选项中，修改授权回调域名，改为当前谷神服务的域名地址。
**注意：**这里填写的是域名（是一个字符串），而不是URL，因此请勿加 http:// 等协议头，如：center.steel56.com.cn。