## 消息模板配置企业微信消息
谷神系统已经集成了企业微信消息，可以在配置消息模板处启用、配置。用此消息模板发送消息时，企业微信已启用会同步发送企业微信消息。
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_14071333c41793253280583f38cba39b_r.png)
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_cb773301b2b86fde043b26a9e20927d1_r.png)

## 自定义消息（请优先使用消息模板）
若消息模板无法满足需求，可通过代码方式调用插件，发送企业微信消息。

**示例：**
#set($service=$vs.service.find('com.golden.faas.plugins.corpwx.message.comps.CorpWechatMsgComps'))
$service.sendTextMsg(null,$userId,"这是一条文本消息！"))

**方法：**
* **文本消息**
	sendTextMsg(String systemId, List userIdList, String content)
	* systemId--系统id，为空默认当前
	* userIdList--接收消息用户列表
	* content--消息内容
* **文本卡片消息**
	sendTextcardMsg(String systemId, List userIdList, String title, String content, String url)
	* systemId--系统id，为空默认当前
	* userIdList--接收消息用户列表
	* userIdList--标题
	* content--消息内容
	* userIdList--详情跳转url
* **图片消息**
	sendImageMsg(String systemId, List userIdList, String path, String fileName)
	* systemId--系统id，为空默认当前
	* userIdList--接收消息用户列表
	* path--谷神系统上传文件后，生成的路径
	* fileName--文件名
* **视频消息**
	sendVideoMsg(String systemId, List userIdList, String path, String fileName, String title, String description)
	* systemId--系统id，为空默认当前
	* userIdList--接收消息用户列表
	* path--谷神系统上传文件后，生成的路径
	* fileName--文件名
	* title--标题
	* description--描述
* **音频消息**
	sendVoiceMsg(String systemId, List userIdList, String path, String fileName)
	* systemId--系统id，为空默认当前
	* userIdList--接收消息用户列表
	* path--谷神系统上传文件后，生成的路径
	* fileName--文件名
* **文件消息**
	sendFileMsg(String systemId, List userIdList, String path, String fileName)
	* systemId--系统id，为空默认当前
	* userIdList--接收消息用户列表
	* path--谷神系统上传文件后，生成的路径
	* fileName--文件名
* **图文消息**
	sendNewsMsg(String systemId, List userIdList, String title, String description, String url, String picurl)
	* systemId--系统id，为空默认当前
	* userIdList--接收消息用户列表
	* title--标题
	* description--描述
	* url--详情跳转地址
	* picurl--显示图片url
* **Markdown消息**
	sendMarkdownMsg(String systemId, List userIdList, String content)
	* systemId--系统id，为空默认当前
	* userIdList--接收消息用户列表
	* content--消息内容，支持Markdown语法