本插件为调用高达自建短信平台的接口插件，若您项目需要使用，则使用步骤如下：
1.  下载插件包：
	[golden-faas-plugins-gdsms.jar](http://docs.steel56.com.cn/uploads/gdfaas/files/golden-faas-plugins-gdsms.jar "插件包")
	插件编码：`com.golden.gdsms`
2. 上传插件包到您需要调用的项目中（注意，若为微服务项目，则每个需要用到短信的微服务都需要依赖此插件）
3. 配置插件
	- 与高达相关人员联系短信开户事宜，并获得短信接口参数（url、appId、通信密钥）
	- 将配置信息维护到系统发布的自定义配置项中（如：application.yml），自定义配置项如下：
	
	```yaml
	golden.sms.url = 短信接口地址，如：http://dataswitch.ecloud123.com/dsclient
	golden.sms.app-id = appId
	golden.sms.mac = 通信密钥
	```
4. 重启服务后，即可访问内置API进行短信发送操作（插件已经把API映射到$vs模块中，您可以通过`$vs.gdsms`来访问短信模块的功能）：
	
	- `$vs.gdsms.sendTimeSMS($mobile:string,$context:string):string`:
		- 函数说明：
		发送即时类短信，如：短信验证码，本接口短信若发送失败，则不会重复发送
		- 参数说明：
			- $mobile : 手机号码（只支持单个，不支持批量）
			- $context: 短信内容，若超长，则根据电信行业规则计费（一般69个字为一条短信）
		- 返回说明：
			- 字符串：success，表示发送成功，其他表示发送失败的错误信息
			
	- `$vs.gdsms.send($mobile:string,$context:string):string`:
		- 函数说明：
		发送通知类短信，如：业务提醒通知，本接口短信若发送失败，则会择机重复发送
		- 参数说明：
			- $mobile : 手机号码（只支持单个，不支持批量）
			- $context: 短信内容，若超长，则根据电信行业规则计费（一般69个字为一条短信）
		- 返回说明：
			- 字符串：success，表示发送成功，其他表示发送失败的错误信息