服务器列表功能模块为管理中心服务添加、管理受管理服务器主机模块。

## 主动添加服务
- 添加新服务器
![](http://docs.guthon.com/uploads/gdfaas/images/m_ba4763cd2ff83c4569f57f607fdb2fa9_r.png)

> [info] 被添加的服务器必须安装并运行运管平台主机客户端服务

## 被动注册服务
Docker模式下，可以使用配置管理中心地址的方式，让主机客户端主动报告并注册到管理中心，配置方式为在主机客户端服务目录下创建`libs`目录（如：`/opt/guthon/servo-client/libs`），并创建文件`application-center.properties`文件，其内容如下：
```
golden.saas.servo.center.address=192.168.xxx.xxx:8086
golden.saas.servo.client.is-docker=1
```
这样启动主机客户端服务后，就会主动注册到管理中心服务中。

> [info] 配置文件中`golden.saas.servo.client.is-docker`为标识当前主机是否为docker的标志，1表示docker环境，0表示物理或虚拟主机。

## 客户端服务升级
#### 在线更新本地客户端安装包版本：

<img style="border:1px solid; display:bolck" src="http://docs.guthon.com/uploads/gdfaas/images/m_a27d2e7d92b8b37ef2bfead260fb602d_r.png" />

点击更新按钮，服务端会自动下载最新的客户端安装包。
> [info] 此模式，仅支持您的管理中心服务器能联通互联网的模式，若您的管理中心服务器不支持联网，则请选择离线升级模式

#### 离线更新本地客户端安装包版本：
<img style="border:1px solid; display:bolck" src="http://docs.guthon.com/uploads/gdfaas/images/m_bc4a07157f7a86661f340c11e0b604c2_r.png" />


#### 升级主机客户端服务：

<img style="border:1px solid;" src="http://docs.guthon.com/uploads/gdfaas/images/m_c5e67e0c271fe67374a6067cf40a2f7c_r.png" />