#### 下载安装包
- 服务器上直接下载
```shell
[root@localhost]$ wget https://file.guthon.com/fileservice/download/guthon-debugger.zip
```
- 安装包文件下载（离线安装包）：[guthon-debugger.zip](https://file.guthon.com/fileservice/download/guthon-debugger.zip)

#### Linux服务安装
- 下载安装包后，上传到服务器（如：/home），并执行安装命令
```
[root@localhost home]$ unzip guthon-debugger.zip
[root@localhost home]$ cd guthon-debugger
[root@localhost guthon-debugger]$ chmod a+x service.sh
[root@localhost guthon-debugger]$ ./service.sh start
[root@localhost guthon-debugger]$ ./service.sh stop
```

#### Window服务安装
- 安装包文件下载（离线安装包）：[guthon-debugger.zip](https://file.guthon.com/fileservice/download/guthon-debugger.zip)
- 解压到您要存放的路径（如： d:\）
- 双击`winstart.bat`启动服务即可

#### 服务升级
- 下载升级包：[guthon-debugger.jar](https://file.guthon.com/fileservice/download/guthon-debugger.jar)
覆盖服务器目录下的文件，重启即可

#### 服务配置
- 服务默认端口为`8070`，若要修改，则在服务目录下，新建 `libs` 目录，然后创建文件 `application-conf.properties`，文件内容如下：
```
server.port = 8070
```
>[info]重启服务后，端口生效
- 运行环境：本服务运行JDK版本为 `jdk1.8`版本，请设置操作系统的默认jdk为1.8，若不是，则请修改 `service.sh`或`winstart.bat` 文件