### 系统初始化
#### 保护密码
- 调试服务不支持多用户模式，而是采用保护密码的方式来保护数据安全
- 若保护密码丢失，则可以删除`$ROOT/libs/config.db`文件即可

#### 初始化项目
- 初次进系统后，需要初始化项目，初始化时，需要填写您要调试的生产环境的主数据数据库连接信息。

#### 系统注册
- 系统默认为`基础版`，若要升级到`专业版`，则在首页`系统信息`中点击`注册码`按钮，根据提示获取和填写注册码即可

#### 运管平台
- 调试服务支持连接`运维管理平台`客户端（要求运管平台客户端版本至少为`202504241715`），您设置了运管数据库信息后，安装应用时，即可通过运管客户端下载相关的系统可执行文件

### 应用管理
#### 应用安装
- 通过运管服务安装：找到对应的运行实例，点击安装即可
- 通过手工复制安装：手工安装需要您先从生产服务器上，将系统运行目录整合打包复制到调试服务本地，并填写您复制后的路径地址，点击方向键按钮即可

### 代码调试
#### 限制规则
一套调试服务只支持一个开发者调试，调试前（包括打代码断点）必须先连接调试服务，调试服务默认不会自动连接，需要用户手工连接(点击右上角的连接状态，可以手工连接调试服务)，若当前已有开发者连接了调试服务，则需要等对方同意后，您才可以连接调试服务。
#### 调试范围
本调试平台支持除系统脚本外的所有后台谷神脚本的调试，代码分类如下：
- 页面模块:
	 - 模块事件，如：保存按钮、表格加载事件等
	 - 服务组件
	 - 控件谷神脚本数据源代码
- 过程函数：所有过程函数
- 下拉组件：谷神脚本数据源下拉组件
- 系统脚本：不支持调试，只支持查看

### REDIS

### 数据库