本文档将引导您实现谷神个性化登录页面UI的开发及配置。
>[info] 注意阅读本文前，需要您掌握插件开发环境设置的前置条件，请开发者自己查阅相关资料。

> 本例插件为基于谷神2.0.0版本开发，可以无故障运行在谷神2.0.0以上版本，1.5.0及以下版本的插件，需要开发者自行解决。

## 登录UI开发
1、请下载本插件源码示例：
- [guthon-plugins-customlogin.zip](https://file.guthon.com/fileservice/download/guthon-plugins-customlogin.zip)

2、下载后目录结构如下：
![](http://docs.guthon.com/uploads/gdfaas/images/m_650e01f813f3fb333f7a8642187f1180_r.png)

3、登录UI开发
根据本插件示例，调整页面HTML，并实现 doLogin 方法以覆盖底层登录函数方法。

4、插件打包
找到插件项目根目录下的`install.bat`，打开，会自动打包，打包后，会生成`$ROOT/target/guthon-plugins-customlogin.jar`，此为插件文件，本例插件的插件编码为`com.guthon.plugins.customlogin`。

5、插件上传
插件打包完成后，您需要登录到开发环境，然后通过插件管理功能模块中，上传本插件，并设置您需要登录的主数据的系统授权（只有系统授权后，才能进行下一步操作）

## 登录设置
1、登录设置
打开开发环境，选择应用管理，找到您需要设置的主数据系统，并选择登录设置菜单，打开登录设置页面
![](http://docs.guthon.com/uploads/gdfaas/images/m_6dd56732a2f0d4a4cb2a3d1516b15c61_r.png)
登录页面选项中，选择`插件页面`，并在页面地址处，下拉选择登录UI页面。