[TOC]

- ### 新建模块
	- 在新建顶级模块时，增加了`是否APP`选项，若当前菜单目录树为预备给APP使用，则请打上勾；若当前菜单目录为PC端使用，则请不要打勾（否则PC端将视为此菜单为APP菜单，而不显示此菜单目录下的所有菜单，哪怕当前用户具有该菜单的权限），设计效果如下图：

	![](http://docs.guthon.com/uploads/gdfaas/images/m_d514e8e1f22b151011b8aaf49939b6b6_r.png)
	> [success] APP菜单目录下的所有目录及菜单都属于APP，在PC端不显示。
	
	<br/>
- ### 新建菜单
	- 建立子目录和菜单与PC开发相同，只是菜单下必须建立一个主页面，切保持为空即可
	
- ### 新建服务组件
	- 建立响应APP请求的`服务组件`，如：
	![](http://docs.guthon.com/uploads/gdfaas/images/m_4de107aedb555cb1bdeea8e905bcf2eb_r.png)
	- `服务组件`的开发和PC端相同，代码如：
	![](http://docs.guthon.com/uploads/gdfaas/images/m_62c2f17ffd4338d9e2440e55da74ec26_r.png)
	> [success] 提示，`$result`为引用对象，不可直接赋值，必须对其属性进行赋值，整个$result会输出给JS回调函数，即，您设置的对象，可以在JS中用同样的属性去访问，访问方式如下：
	
	``` 
	gUtil.request('com.golden.bdp.wms.mobile.outgoods.demo',function(result){
		var form = result.form; // <-- 这个就是设置的类
	});
	```
	
- ### 服务组件和菜单权限关联
	- 服务组件本身是可以挂载权限的，如下图：
	![](http://docs.guthon.com/uploads/gdfaas/images/m_75af2176151d5a85f8e0ebbac80dc46c_r.png)
	- 这里设置的是`submit`提交权限（当然您也可以自己定义权限类型）
	- 打开菜单的主页面->窗口设置->页面事件->onOpen
	![](http://docs.guthon.com/uploads/gdfaas/images/m_733f032be77d4ba78e726b2216a19b90_r.png)
	- 加上调用服务组件的代码，把服务组件和主窗口关联，如：
	![](http://docs.guthon.com/uploads/gdfaas/images/m_c89eada55ca553c7ba710f02425260d2_r.png)
		
	- 至此，服务组件即和菜单权限关联，在用户分配权限时，就会出现当前服务组件的子权限了，操作员必须具有当前菜单下，当前服务组件所指定的子权限（`submit`）才可调用这个服务组件，此时的权限分配界面如下：
	![](http://docs.guthon.com/uploads/gdfaas/images/m_162d77f9fb8e55031193a0aab5d24abd_r.png)
	
	> [success] 提示，谷神针对服务组件的子权限体系是根据当前页面是否调用来确定的。