发布日期：`2021-04-08`

- ## 新增功能
	- 操作权限调整：
		- 1、系统管理员可以分配所有菜单及按钮权限
		- 2、普通操作员（含管理员）只能分配其所拥有的权限及按钮权限（数据权限类似）
		- 3、分配权限不能操作自己本身的权限（数据权限类似）
		- 4、除系统管理员外，其他所有操作员（含管理员）均需要分配权限才能访问功能
		- 5、增加权限分配日志
	- 增加缓存操作方法：
		- `$vs.cache.getImageRandomCode()`:获取缓存中的图片验证码
	- 增加cookie操作方法：
		- `$vs.cookie.writeCookie(cookieName,cookieValue,expTime,path)`:写普通cookie
		- `$vs.cookie.writeSessionCookie(cookieName,cookieValue,path,httpOnly)`:添加会话cookie
		- `$vs.cookie.removeCookie(cookieName,path)`:删除cookie
		- `$vs.cookie.getCookie(cookieName)`: 获取cookie
	- 增加三方系统接口UI配置界面
		打开方法：以超级管理员（0000）身份登录，点击右上角头像，选择“系统设置”菜单
		![](http://docs.guthon.com/uploads/gdfaas/images/m_e5b1af58252d163698894b3421784125_r.png)
		
	- 增加三方系统接口权限设置功能，允许限制三方系统调用服务组件的范围
	- `过程函数`设计界面调整、增加签出、提交、版本记录等功能
	- 打包时，`页面模块`、`系统脚本`、`过程函数`这三类代码只提取已提交的代码发布，请注意提交已开发完成的代码后再打包发布
	- `页面模块`、`系统脚本`、`过程函数`增加`撤销版本`功能
	- 模块开发增加`查看我签出的页面`功能，方便开发者查看自己签出的代码
	- 增加对帆软报表的支持
	- 模块开发`查看我签出的页面`中，增加强制提交、强制撤销他人签出修改的页面功能；增加查询所有签出页面的功能
	- 过程函数添加`代码查询器`和`查看我签出的页面`模块，增加强制提交、强制撤销他人签出修改的页面功能；增加查询所有签出页面的功能
	- 支持数据库存储过程调用:`$vs.dbTools.callProc($proName:string,$params:object...):ProcResult`
	- 增加`应用参数管理`功能，可以设置应用级参数，可以方便在GusenLanguage和JavaScript中访问
		- `$vs.property.getSystemVarValue()`:服务脚本获取参数值
		- `$vm.getSystemVarValue()`：窗口js脚本获取参数值
		- `gUtil.getSystemVarValue()`：其他js脚本获取参数值
- ### 1.2.7.6
	- 主数据表格增加相同数据自动合并单元格功能
	- inputForm和gridForm增加label默认宽度设置功能
	- 修复gridForm控件不能调整label宽度的缺陷
	- 修复外连接表被添加了数据权限约束问题（外连接表不添加数据权限约束）
	- 底层依赖包升级：
	
序号|项目|原版本|新版本
:-:|:-|:-|-
1|spring-boot		|2.2.2.RELEASE	|2.3.10.RELEASE
2|spring-cloud		|Hoxton.RELEASE	|Hoxton.SR11
3|spring-framework	|5.2.2.RELEASE	|5.2.14.RELEASE
4|hibernate			|5.4.9.Final	|5.4.30.Final
5|mybatis			|3.5.1			|3.5.6