发布日期：`2021-09-18`

- ## 新增功能
	- 增加业务日志记录功能（需要启用`日志中心系统`功能后生效）
		- 在单据（有单据类型设置的模块）中新增、修改时自动记录业务日志
		- 在调用`$vm.remove`时自动保存删除日志
		- 增加个性化日志保存方法`$vs.log.writeBusLog($billTypeCode:string,$billNo:string,$optType:string,$bill:object)`，用于其他情况下记录业务日志（如：单据审核）
	- 查询字段增加`默认模糊`选项，只有在`允许模糊`和`禁用高级查询`开启的时候才会出现
	- 服务组件增加`地址映射`功能，地址映射是映射一个可以直接访问的链接地址，如：/gdpaas/comp/xxx/method.htm，用户可以根据这个地址直接访问并调起本服务组件，此功能一般用于接口.
	![](http://docs.guthon.com/uploads/gdfaas/images/m_8ba6c959bcd0cc9ebfced90dfd13c167_r.png)
	- 表格属性中，增加`列排序`功能，可以在此页面拖动列进行排序
	![](http://docs.guthon.com/uploads/gdfaas/images/m_374baeef7dc9cdb95fe59074c26db5e8_r.png)
	- 增加`$vs.util.newList($obj...)`方法，用于初始化list时自动增加元素
	- 增加`$vs.dbTools.batchUpdate($strTableName,$datas,$wheres)`批量update方法，用法如下：
	```
	
	#set($item1 = $vs.util.newMap())
	#set($item1.ORG_ID = 51)
	#set($item1.ORG_CODE = '0046')
	
	#set($item2 = $vs.util.newMap())
	#set($item2.ORG_ID = 52)
	#set($item2.ORG_CODE = '0047')
	
	#set($item3 = $vs.util.newMap())
	#set($item3.ORG_ID = 53)
	#set($item3.ORG_CODE = '0048')
	
	#set($item4 = $vs.util.newMap())
	#set($item4.ORG_ID = 54)
	#set($item4.ORG_CODE = '0049')
	#set($list=$vs.util.newList($item1,$item2,$item3,$item4)) // 把元素添加到列表，方便后面的循环
	
	#set($datas=$vs.util.newList()) // 创建需要更新的数据列表
	#set($wheres=$vs.util.newList()) // 创建需要更新的条件列表
	#foreach($item in $list)
		#set($data = $vs.util.newMap())
		#set($data.ORG_PHONE = "ORG_PHONE-" + $item.ORG_CODE)
		#set($data.ORG_ID = $item.ORG_ID)
		#set($data.ORG_FAX = "FAX12-" + $item.ORG_CODE)
		#set($data.ORG_ACCOUNTS = null)
		
		#set($where = $vs.util.newMap())
		#set($where.ORG_ID = $item.ORG_ID) 
		#set($where.MEMBER_CODE = "0000")
		#set($where.ORG_CODE = $item.ORG_CODE) // <-- 若被更新的表是缓存表，则必须带缓存字段
		
		$datas.add($data);
		$wheres.add($where);
	#end
	
	$vs.dbTools.batchUpdate('BASIC_ORG',$datas,$wheres);
	```
	- 表格增加`table.findHtmlDocument()`方法，用于查找表格控件下的自定义html内容。
	- 导场景升级优化
	- 系统导出编译优化
	- 增加保存/创建文件方法：
		- `$vs.file.saveBytesToFile($fileName,$buffer)`
		- `$vs.file.saveStringToFile($fileName,$context)`
	- 单据类型设置中，增加号码分割符设置，可以设置单据号码分割规则
	- 打包配置增加`打包文件名`选择用于打包后打包文件命名，来区分不同项目的打包文件
	- 开发环境系统属性编辑中，增加`产品版本`和`项目版本`
	- 代码编译中增加记录当前系统版本
	- 增加打包记录功能
	- 增加`hmacSHA256`摘要加密算法：
		- `$vs.cipher.hmacSHA256($data,$secert)`
		- `$vs.cipher.hmacSHA256B($data,$secert)`
	- 增加字符串字节转换函数：
		- `$vs.util.strToBytes($str,$charset)`
		- `$vs.util.bytesToString($buffer,$charset)`
	- 增加编译并获取消息模版内容方法：
		- `$vs.message.buildMessageContext($userId:string,$msgTypeId:string,$bill:object):string`