## 工作台
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_d58056ca6a9f576bbc17711cb2d55a8d_r.png)

## 1. 添加服务
* 点击工具栏按钮![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_e7df5d15ee01a9f33757decc6bca335b_r.png)，填写服务连接信息（**注意服务IP不支持IPV6**）
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_012b13a4cf19b1a01023c9aaac3268aa_r.png)
* 支持ssh隧道连接，ssh隧道是通过跳转机连接目标服务器
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_5f20d72f262d8ef87e47d03442f56dc0_r.png)
* 点确定后，会提示是否进行安全加固扫描，点确定进行扫描
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_ae8c1d11721d7a7f8261ee559cfc1f46_r.png)
* 根据需求对扫描结果进行修复
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_41e195541d19b307a28cf5cb8293bfa8_r.png)

## 2. 编辑、移除服务
点击工具栏按钮![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_e91c7e5e4b7bc2a779af3fcf25b2730f_r.png)，分别进行编辑、移除服务

## 3. JDK安装
* 点击工具栏按钮![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_dfbfda2f15686f1d560dda874c2b8e8c_r.png)进入服务配置界面，再点击**安装JDK**按钮，进行安装配置；注：安装前会进行jdk版本的校验
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_bdd1cce2fabe2e6742c79497966d2761_r.png)

## 4. 时间服务安装（NTP服务）
* 进入服务配置界面，再点击**安装时间服务**按钮，进行安装
* NTP配置界面如下，服务类型分为服务端、客户端。默认有几个订阅地址，也可自行添加其他服务。授权为广播地址，工具会读取服务器网卡配置信息做为默认值，可自行修改
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_3a940b054ad0ea5c514521898db188df_r.png)
* 点确定后进入安装界面，如果机器不能连外网，第一次同步时间可能会报错，建议安装时间服务时保持网络畅通

## 5. 安装文件服务
* 进入服务配置界面，再点击**安装文件服务**按钮，进行安装
* 选择磁盘分区时，需选择可用空间较大的挂载点，然后等待安装完成即可

## 6. 调整文件数限制
* 进入服务配置界面，再点击**调整文件数限制**按钮，等待配置完成即可

## 7. 优化网络配置
* 进入服务配置界面，再点击**优化服务器网络配置**按钮，等待配置完成即可

## 8. 关闭SELINUX
* 进入服务配置界面，再点击**关闭SELINUX**按钮
* 等待配置完成，有时会提示重启生效，根据需求选择是否立即重启

## 9. RPM包管理
* 进入服务配置界面，再点击**RPM包管理**页签，可管理安装第三方RPM包
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_041cb3736c3b6ec7d1ae6ec9872761f6_r.png)

## 10. 终端
点击工具栏按钮![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_78731646ed5126d985c6975cc0e76d7d_r.png)可打开linux终端，进行终端操作
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_1f94dc5c30d1bd631153fc4ff1127150_r.png)

## 11. 文件传输
点击工具栏按钮![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_01dc6111ec59820c985131a308c7df8e_r.png)可打开文件传输窗口，使用拖拽的方式，进行上传、下载
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_896eccc3a5c7b70b8cc63e912e297ff7_r.png)

## 12. 防火墙管理
点击工具栏按钮![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_046582d8936e0cfa4be5cb0655ffdcd3_r.png)打开防火墙管理窗口，可开发或禁用已开发的端口，开放端口支持范围开发，如80-443
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_ca0daa913c249eab838a90af8f974056_r.png)