## 配置项

配置项|必须|说明
:-:	|:-|:-
**golden.corpwechat.corp-id**|是|企业ID
**golden.corpwechat.agent-id**|是|应用ID
**golden.corpwechat.agent-secret**|是|应用密钥
**golden.system.domain**|否|服务公网域名，如果使用域名+端口，再用nginx转发，则获取端口可能会失败，需配置此项。配置如：http://abc.gusen.steel56.com:8080

## 获取配置信息
* **CorpId**
登录管理后台后，点击“我的企业”->“企业信息”，在企业信息的最下方可以获取您的CorpId
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_f1920524749ecd1bae2c8e52d19512f4_r.png)
* **AgentId、Secret**
请通过管理后台->应用管理->应用 找到您的应用，点击应用进入设置界面。在此可以获得应用的AgentId、Secret
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_31ac106e495fb6413cd7a8726e85b7f3_r.png)
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_c948cfb4fc851f64d51217e9445d4c5f_r.png)

## 消息推送地址修改
用系统管理员账号登录http://现场环境域名/gdpaas/login/index.htm。右上角头像-->系统设置-->消息模板设置-->找到企业微信消息模板-->修改详情地址
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_ffe88cffa28a591d64e4dbbf2a6870ab_r.png)
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_ced97cd7b58f493089fd4c60a7a1eb89_r.png)
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_f9afa93dc94871e9d126ba2daeced003_r.png)
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_7479ff15b539db6266e35234f5150c56_r.png)

## 绑定企业微信
* 手机端
手机上需要安装企业微信，在企业微信工作台，可看到对应的应用，点对应应用，可绑定（输入PC端的登录账号绑定）
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_8cf437b19efd0de0205a03559565fcf9_r.png)
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_58f05584b186bb7c70e7fb5451889543_r.png)

* PC端
登录界面会出现企业微信，点企业微信可扫码登录（如未绑定，扫码后进入绑定页面，输入PC端的登录账号绑定）
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_89fdcd3098a6b9b968379568f7e23e5d_r.png)

## 解绑企业微信
主数据库，用户表basic_user清空对应用户的CW_OPEN_ID。
**谨慎使用，主要用于客户测试环境切换到客户正式环境时，不再接收客户测试环境推送的企业微信消息。修改具体可咨询研发主管。**
SELECT a.CW_OPEN_ID,a.* FROM basic_user a WHERE a.USER_NAME='taozi';