本插件为谷神整合基于`flowable`的工作流插件，若您项目需要使用，则使用步骤如下：
1. 请注意：本插件必须在谷神`2.0.0`及以上版本使用，`1.5.0`以下版本已内置此工作流插件。
2. 下载插件包：
	 - [golden-faas-plugins-workflow-2.0.0-SNAPSHOT.jar](https://file.guthon.com/fileservice/download/golden-faas-plugins-workflow-2.0.0-SNAPSHOT.jar)
	 - 插件编码：`com.golden.faas.plugins.workflow`
3. 上传插件包到您需要调用的项目的主数据中（`注意：仅主数据服务需要关联使用`）
4. 包含依赖包及版本：

序号|groupId				|artifactId			  |版本
:-|:-					|:-							|:-
1 | org.flowable		| flowable-spring-boot-starter-process 	| 6.4.1
2 | org.flowable		| flowable-spring-boot-autoconfigure 	| 6.4.1
3 | org.flowable		| flowable-spring-security 				| 6.4.1
4 | org.flowable		| flowable-engine 						| 6.4.1
5 | org.flowable		| flowable-bpmn-converter 				| 6.4.1
6 | org.flowable		| flowable-bpmn-model 					| 6.4.1
7 | org.flowable		| flowable-process-validation 			| 6.4.1
8 | org.flowable		| flowable-image-generator 				| 6.4.1
9 | org.flowable		| flowable-engine-common-api 			| 6.4.1
10| org.flowable		| flowable-engine-common 				| 6.4.1
11| org.flowable		| flowable-variable-service-api 		| 6.4.1
12| org.flowable		| flowable-variable-service 			| 6.4.1
13| org.flowable		| flowable-identitylink-service 		| 6.4.1
14| org.flowable		| flowable-identitylink-service-api 	| 6.4.1
15| org.flowable		| flowable-entitylink-service 			| 6.4.1
16| org.flowable		| flowable-entitylink-service-api 		| 6.4.1
17| org.flowable		| flowable-task-service 				| 6.4.1
18| org.flowable		| flowable-task-service-api 			| 6.4.1
19| org.flowable		| flowable-job-service 					| 6.4.1
20| org.flowable		| flowable-job-service-api 				| 6.4.1
21| org.flowable		| flowable-idm-api 						| 6.4.1
22| org.flowable		| flowable-idm-engine 					| 6.4.1
23| org.flowable		| flowable-idm-engine-configurator 		| 6.4.1
24| org.flowable		| flowable-cmmn-api 					| 6.4.1
25| org.flowable		| flowable-cmmn-model 					| 6.4.1
26| org.flowable		| flowable-dmn-api 						| 6.4.1
27| org.flowable		| flowable-dmn-model 					| 6.4.1
28| org.flowable		| flowable-form-model 					| 6.4.1
29| org.flowable		| flowable-form-api 					| 6.4.1
30| org.flowable		| flowable-content-api 					| 6.4.1
31| org.flowable		| flowable-spring 						| 6.4.1
32| org.flowable		| flowable-spring-common 				| 6.4.1
33| org.flowable		| flowable-job-spring-service 			| 6.4.1
34| com.fasterxml.uuid	| java-uuid-generator 					| 3.1.5
35| org.apache.commons	| commons-email 						| 1.5
36| joda-time			| joda-time 							| 2.10.1