管理中心服务安装完成并启动成功后，第一次访问此服务，系统需要用户进行初始化操作，本文将讲解初始化过程

### 数据库设置
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;管理中心服务支持本地文件数据库（SQLite）或者其他谷神系统支持的关系数据库，需注意的是，本地文件数据库由于性能级数据安全方面的原因，其`不支持服务器监控功能`，一般普通项目维护可以使用，大项目一般建议使用其他关系数据库。
![](http://docs.guthon.com/uploads/gdfaas/images/m_0b4563ff95afe0940233cdfbc1432f6b_r.png)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;根据实际需求填写数据库参数，然后选择`下一步`按钮。

> [info] 提示：本地文件数据库不支持系统监控

### 系统类型设置
![](http://docs.guthon.com/uploads/gdfaas/images/m_ad9101b09f0a4c417e248bcb7532395b_r.png)
管理中心服务工作模式分为`单项目版`和`多项目版`两个版本，他们关系如下：
- 单项目版：适用于单个项目，系统界面简洁明了，易于使用
- 多项目版：一般用于SAAS供应商管理基于谷神开发的SAAS服务，管理各个客户的谷神服务实例，功能相对比较复杂，`单项目慎用`。

> [info] 提示：
1、系统类型设置后，后期无法变更，请谨慎选择。
2、若您选择了单项目版，则需要填写使用单位名称，同样的，使用单位名称后期无法更改，请谨慎填写。

### 管理员账号设置
![](http://docs.guthon.com/uploads/gdfaas/images/m_405caf5755468215d4586ec9df6902bc_r.png)
设置系统初始化管理员账号。

> [info] 提示：管理中心服务尽量不要发布到公网，若发布到公网，请设置复杂密码，且尽量不要用`admin`作为登录账户名称，防止暴力密码攻击。

### 设置完成
![](http://docs.guthon.com/uploads/gdfaas/images/m_0db3ebc99d748e8d839ef35397e4cab2_r.png)

设置完成后，服务会自动重启，请稍等一会。